package Counter;

/**
* Illustrates use of semaphores
*/
public class BoundedCounterVSem implements BoundedCounter {
	protected long count_ = MIN;
	protected Semaphore mutex;
	protected Semaphore full;
	protected Semaphore empty;

	BoundedCounterVSem() {
		mutex = new Semaphore(1);
		full = new Semaphore(0); // number of items
		empty = new Semaphore(MAX-MIN); // number of slots
	}
	
	public long value() {
		mutex.down(); // grab the resource
		long val = count_;
		mutex.up(); // release it
		return val;
	}

	public void inc() {
		empty.down(); // grab a slot
		mutex.down();
		count_ ++;
		mutex.up();
		full.up(); // release an item
	}

	public void dec() {
		full.down(); // grab an item
		mutex.down();
		count_ --;
		mutex.up();
		empty.up(); // release a slot
	}

	/*
	* These would cause a nested monitor problem!
	*/
	public void BADinc() {
		mutex.down();
		empty.down(); // grab a slot
		count_ ++;
		full.up(); // release an item
		mutex.up();
	}

	public void BADdec() {
		mutex.down();
		full.down(); // grab an item
		count_ --;
		empty.up(); // release a slot
		mutex.up();
	}
}
