/*
  File: CountDown.java

*/

package counterdownSol;

import java.applet.*;
import support.NumberPanel;

/**
 * CountDown
 *
 **/

public class CountDown extends Applet implements Runnable
{
	int i_;
	
	final static int N = 10;
  
	AudioClip beepSound_; 
	AudioClip tickSound_;

	NumberPanel display_;

	public void init() 
	{
		display_ = new NumberPanel( "Counter" );
		display_.setSize( getSize() );
		add( display_ );
		tickSound_ = getAudioClip( getDocumentBase(), "Sound/tick.au" );
		beepSound_ = getAudioClip( getDocumentBase(), "Sound/beep.au" );
	}

	public void start() 
	{
		new Thread(this).start();
	}
	
	public void run() {
		i_ = N;
		display_.setValue( i_ );
		while (notFinished()) {
				tick();
				}
		beep();
	}
	
	private boolean notFinished() {
		return i_ > 0;
	}

	public void stop() 
	{
	}

	private void tick()
	{
		i_--;
		try { 
			Thread.sleep( 1000 );
		} catch (InterruptedException e) {
			return; 
		}
		display_.setValue( i_ ); 
		tickSound_.play();
	}

	private void beep()
	{
		display_.setValue( i_ ); 
		beepSound_.play();
	}

}

