/*
  File: Fork.java
*/

package dinersSol;

public class Fork 
{
	private boolean taken_ = false;
	private PhilTable view_;
	private int id_;

	Fork( PhilTable view, int id )
	{ 
		view_ = view; 
		id_ = id;
		view_.setForkState( this );
	}

	public int getId()
	{
		return id_;
	}

	public boolean getState()
	{
		return taken_;
	}

	public void init()
	{
		taken_ = false;
		view_.setForkState( this );
	}

	synchronized void put() 
	{
		taken_ = false;
		view_.setForkState( this );
		notify();
	}

	synchronized void get() throws InterruptedException 
	{
		while ( taken_ ) 
			wait();
		if ( !((RunnablePhilosopher)Thread.currentThread()).isTerminated() )
			{
				taken_ = true;
				view_.setForkState( this );
			}
		else
			throw new InterruptedException( "thread terminated" );
	}

}
