/*
  File: BoundedBuffer.java
*/

package buffer;

public class BoundedBuffer implements Buffer
{

	private Object buffer_[];

	private int size_;

	private int count_;

	private int in_;

	private int out_;

	public BoundedBuffer( int size )
	{
		size_ = size;
		init();
	}

	public void init()
	{
		buffer_ = new Object[size_];
		count_ = 0;
		in_ = 0;
		out_ = 0;
	}

	public synchronized void put( Object o ) throws InterruptedException
	{
		buffer_[in_] = o;
		count_++;
		in_ = (in_ + 1) % size_;
	}

	public synchronized Object get() throws InterruptedException
	{
		Object o = buffer_[out_];
		buffer_[out_] = null;
		count_--;
		out_ = (out_ + 1) % size_;
		return o;
	}

	int getIn()
	{
		return in_;
	}

	int getOut()
	{
		return out_;
	}

	char[] getCharBuffer()
	{
		char[] result = new char[size_];

		for ( int i = 0; i < size_; i++ ) 
			{
				if ( buffer_[i] != null )
					try
						{
							result[i] = ((Character)buffer_[i]).charValue();
						}
					catch (Exception e)
						{
							result[i] = ' ';
						}
				else
					result[i] = ' ';
			}
		return result;
	}
	
}
