/**
* OvertakingAllocator Class
*/

package golfSol;

public class OvertakingAllocator extends SimpleAllocator
{
	private int turn_ = 0;
	private int next_ = 0;
	private int bound_;
	private int overtaken_ = 0;

	public OvertakingAllocator(int n, int b) 
	{ 
		super(n); bound_ = b;
	}

	synchronized public void get(int n)
		throws InterruptedException {
		int myturn = turn_;
		++turn_;
		boolean overtakenMe = false;
		while (n>available_ || (overtaken_>0 && !overtakenMe)) {
			wait();
			if ((next_>= (myturn + bound_)) && !overtakenMe) {
				overtakenMe = true; ++overtaken_;
			}
		}
		if (overtakenMe) --overtaken_;
		++next_;
		available_ -= n;
		notifyAll();
	}

	public String getTitle() 
	{
		return "OvertakingAllocator"; 
	} 

 }
