/********************************************************/
//
// SimpleAllocator Class
//
package golfSol;

public class SimpleAllocator implements IAllocator
{

	protected int available_; // not private!
	final int capacity_; 

	public SimpleAllocator(int n) 
	{ 
		capacity_ = n; 
		available_ = n; 
	}

	synchronized public void get(int n) throws InterruptedException 
	{
		while ( n > available_ ) 
			wait();
		available_ -= n;
	}

	synchronized public void put(int n) 
	{
		available_ += n;
		notifyAll();
	}

	public int getCapacity() {
		return capacity_; 
	}

	public String getTitle() 
	{
		return "SimpleAllocator"; 
	} 

 }
