/*
  File: RotatorPanel.java
*/

package doublerotator;

import java.awt.*;
import java.awt.event.*;
import support.*;

public class RotatorPanel extends Panel
{
	ArcPanel arcPanel_;
	Button run_;
	Button pause_;

	static final Color RUNCOLOR = Color.green;
	static final Color PAUSECOLOR = Color.red;

	public RotatorPanel( String title )
	{
		this( new BorderLayout(), title );
	}

	public RotatorPanel( LayoutManager layout, String title )
	{
		super( layout );

		Panel p = new Panel();
		run_ = new Button( "Run" );
		run_.addActionListener( new RunListener( this ) );
		pause_ = new Button( "Pause" );
		pause_.addActionListener( new PauseListener( this ) );
		p.add( run_ );
		p.add( pause_ );

		arcPanel_ = new ArcPanel( title );
		add( arcPanel_, BorderLayout.NORTH );
		add( p, BorderLayout.SOUTH );
	}

	public void setZero()
	{
		// arcPanel_.setZero();
		setInActive();
	}

	public void setActive()
	{
		run_.setEnabled( false );
		pause_.setEnabled( true );
		arcPanel_.setBackground( RUNCOLOR );
	}

	public void setInActive()
	{
		run_.setEnabled( true );
		pause_.setEnabled( false );
		arcPanel_.setBackground( PAUSECOLOR );
	}

	public void start() 
	{
		setZero();
	}

	public void stop() 
	{
	}

	class RunListener implements ActionListener
	{
		RotatorPanel owner_;

		public RunListener( RotatorPanel owner )
		{
			owner_ = owner;
		}

		public void actionPerformed( ActionEvent evt )
		{
			owner_.setActive();
		}

	}

	class PauseListener implements ActionListener
	{
		RotatorPanel owner_;

		public PauseListener( RotatorPanel owner )
		{
			owner_ = owner;
		}

		public void actionPerformed( ActionEvent evt )
		{
			owner_.setInActive();
		}

	}

}
